#! /usr/bin/python
# -*- coding: utf-8 -*-
import cv2
import json
import time
from datetime import datetime
import urllib2
import urllib
import dateutil.parser
from poster.encode import multipart_encode
from poster.streaminghttp import register_openers
import argparse

BUTTON = 20
LED    = 16

accuracy = 70

models_cat = ['scene', 'fashion_pattern', 'fashion_type', 'fashion_style', 'fashion_color', 'food', 'flower', 'kinoko']

docomo_key='xxx'
URL_CAT   ='https://api.apigw.smt.docomo.ne.jp/imageRecognition/v1/concept/classify/?APIKEY='

def getImage(fname, modelName):
    register_openers()
    f = open(fname, 'r')
    url = URL_CAT
    datagen, headers = multipart_encode({'image': f, 'modelName': modelName})

    url = url + docomo_key
    request = urllib2.Request(url,datagen, headers)
    response= urllib2.urlopen(request)
    res_dat = response.read()

    res_json = json.loads(res_dat)['candidates']

    return res_json


if __name__ == '__main__':
    parser = argparse.ArgumentParser()
    parser.add_argument('--image' ,dest='image', type=str, default='', help='name of input image')
    parser.add_argument('--model', dest='model', type=str, default='', help='modelName = {scene, fasion_pattern, fashion_type, fashion_style, fashion_color, food, flower, kinoko, bodyPart, currency}')

    args = parser.parse_args()
    model_name = args.model if args.model in models_cat else ''
    fname = args.image if args.image else 'image.jpg'
    print model_name, fname

    if fname:
        img = cv2.imread(fname)
        candidate_list = []
        if model_name == '':
            for model in models_cat:
                candidate_list += getImage(fname, model)
        else:
            candidate_list = getImage(fname, model_name)
        print candidate_list

        obj= 0
        objects = ''
        message = 'No message'
        if candidate_list:
            for can in candidate_list:
                score    = round(can['score']*100, 1)
                object   = can['tag']
                obj_model= model_name
                if score > accuracy:
                    obj +=1
                    print object + "(" + str(score) + "%)"
                    if object: objects += object + ', '
            message = str(obj) + " object detected: "
            if objects:
                message += objects.encode('utf-8')
        else:
            message = "No candidate"
    if message:
        print message
    else:
        print "No message"
